import React from 'react';
import PropTypes from 'prop-types';

/**
 * @class Flex
 */
class Flex extends React.Component
{

	static propTypes = {
		reverse: PropTypes.bool,
		start: PropTypes.arrayOf(
			PropTypes.string
		),
		center: PropTypes.arrayOf(
			PropTypes.string
		),
		end: PropTypes.arrayOf(
			PropTypes.string
		),
		top: PropTypes.arrayOf(
			PropTypes.string
		),
		middle: PropTypes.arrayOf(
			PropTypes.string
		),
		bottom: PropTypes.arrayOf(
			PropTypes.string
		),
		around: PropTypes.arrayOf(
			PropTypes.string
		),
		between: PropTypes.arrayOf(
			PropTypes.string
		),
		first: PropTypes.arrayOf(
			PropTypes.string
		),
		last: PropTypes.arrayOf(
			PropTypes.string
		),
		children: PropTypes.node
	};

	/**
	 * @constructor
	 */
	constructor()
	{
		super();
	}

	/**
	 * Lifecycle method
	 * Will Component Mounted
	 * @return {void}
	 */
	componentWillMount()
	{
		this.class = `
		${ this.props.reverse ?
			"reverse" :
			"" }
		${ this.props.start ? 
			Flex.generateClassNames( 'start', this.props.start ) : 
			"" }
		${ this.props.center ?
			Flex.generateClassNames( 'center', this.props.center ) :
			"" }
		${ this.props.end ?
			Flex.generateClassNames( 'end', this.props.end ) :
			"" }
		${ this.props.top ?
			Flex.generateClassNames( 'top', this.props.top ) :
			"" }
		${ this.props.middle ?
			Flex.generateClassNames( 'middle', this.props.middle ) :
			"" }
		${ this.props.bottom ?
			Flex.generateClassNames( 'bottom', this.props.bottom ) :
			"" }
		${ this.props.around ?
			Flex.generateClassNames( 'around', this.props.around ) :
			"" }
		${ this.props.between ?
			Flex.generateClassNames( 'between', this.props.between ) :
			"" }
		${ this.props.first ?
			Flex.generateClassNames( 'first', this.props.first ) :
			"" }
		${ this.props.last ?
			Flex.generateClassNames( 'last', this.props.last ) :
			"" }
		`;
	}

	/**
	 * Generate class Name for displays
	 * @param {string} name - class name
	 * @param {array} displays - specified displays
	 * @return {string} generated classes
	 */
	static generateClassNames( name, displays )
	{
		return displays.reduce( ( accumulator, currentValue ) =>
		{
			return `${ accumulator } ${ name }${ ( ( string ) => 
			{
				return string.charAt( 0 ).toUpperCase() + string.substring( 1 );
			} )( currentValue ) }`;
		}, "" );
	}

	/**
	 * Render Component
	 * @return {XML} xml
	 */
	render()
	{
		return (
			<div className={ `row ${ this.class }` }>
				{ this.props.children }
			</div>
		);
	}
}

export default Flex;